<template>
  <el-card
    class="page-table scrollable only-y"
    id="affix-container"
  >
    <div class="">
      <h1>Jobs
        <!--<span v-if="!loading" class="lbl-verify">-->
        <!--<label v-if="detail.isVerified" class="lbl lbl-success">Verified</label>-->
        <!--<label v-else class="lbl label-default">Unverified</label>-->
        <!--</span>-->
      </h1>
      <!--<h4>for a better experience on Mac OS during horizontal scroll is prefered disable the "Swipe between pages" option </h4>-->
      <div class="page-status">

        <el-breadcrumb separator="/">
          <el-breadcrumb-item :to="{ path: '/' }"><i class="mdi mdi-home-outline"></i></el-breadcrumb-item>
          <el-breadcrumb-item :to="{ path: '/jobs' }">Jobs</el-breadcrumb-item>
          <el-breadcrumb-item v-if="!detail.name">None</el-breadcrumb-item>
          <el-breadcrumb-item
            v-if="detail.name"
            :to="{ path: '/jobs/'+ $route.params.id }"
          >{{(detail.name &&  detail.name.length < 50) ? detail.name :  detail.name.substring(0,50)+'...' }}</el-breadcrumb-item>
          <el-breadcrumb-item>Edit</el-breadcrumb-item>
        </el-breadcrumb>
      </div>
    </div>
    <br />
    <el-card
      v-if="isContentFound"
      v-loading="loading"
    >
      <not-found></not-found>
    </el-card>
    <div v-else>
      <div
        class="box-card"
        v-loading="loading"
      >
        <div
          class="card-inner"
          v-if="detail"
        >
          <div class="line">
            <div class="">
              <el-row :gutter="5">
                <draggable
                  v-model="listImage"
                  :move="getPostion"
                  @start="drag=true"
                  @end="updatePostionImage"
                >
                  <el-col
                    :xs="24"
                    :sm="12"
                    :md="4"
                    v-for="(item, index) in listImage"
                    :key="index"
                    v-loading="imageLoading"
                  >
                    <el-upload
                      :id="index"
                      :auto-upload="false"
                      class="avatar-uploader companyCover"
                      action="https://jsonplaceholder.typicode.com/posts/"
                      :show-file-list="false"
                      :disabled="(item.src ? true : false)"
                      drag
                      :on-change="onChangeIconHandle[index]"
                    >

                      <div
                        v-if="item.src"
                        style="height: 100%; width: 100%; display: flex"
                      >
                        <div
                          v-if="item.src"
                          style="height: 100%; width: 100%; display: flex"
                        >
                          <img
                            :src="item.src"
                            class="avatar"
                          >
                          <el-button
                            width=32
                            height=32
                            @click="onRemoveImg($event,item.id, index)"
                            class="icon-img-close-employer"
                            icon="el-icon-close"
                            type="info"
                            circle
                            mini
                            plain
                          ></el-button>
                        </div>

                      </div>
                      <i
                        v-else
                        class="el-icon-plus avatar-uploader-icon"
                      ></i>
                    </el-upload>

                  </el-col>
                </draggable>

              </el-row>

            </div>
          </div>

          <el-card
            shadow="never"
            class="form-box"
            style="margin-top: 20px"
          >
            <el-form
              :rules="rules"
              ref="detail"
              :model="detail"
            >
              <el-row :gutter="30">
                <el-col
                  :span="12"
                  :md="12"
                  :sm="24"
                  :xs="24"
                  class="col-p"
                >
                  <el-form-item
                    label="Category"
                    prop="categorySelected"
                  > <br>
                    <el-select
                      v-model="detail.categorySelected"
                      placeholder="Select"
                      :label="detail.categorySelected.name"
                    >
                      <el-option
                        v-for="item in categoriesOptions"
                        :key="item.id"
                        :label="$helper.replaceUnderscore(item.name)"
                        :value="item.id"
                      >
                      </el-option>
                    </el-select>
                  </el-form-item>
                </el-col>
                <el-col
                  :span="12"
                  :md="12"
                  :sm="24"
                  :xs="24"
                  class="col-p"
                >
                  <el-form-item
                    label="Employment Option"
                    prop="employmentOptionSelected"
                  ><br>
                    <el-select
                      v-model="detail.employmentOptionSelected"
                      placeholder="Select"
                    >
                      <el-option
                        v-for="item in employmentOptions"
                        :key="item"
                        :label="$helper.replaceUnderscore(item)"
                        :value="item"
                      >
                      </el-option>
                    </el-select>
                  </el-form-item>
                </el-col>
                <el-col
                  :span="12"
                  :md="12"
                  :sm="24"
                  :xs="24"
                  class="col-p"
                >
                  <el-form-item
                    label="Employment Type"
                    prop="employmentTypeSelected"
                  ><br>
                    <el-select
                      v-model="detail.employmentTypeSelected"
                      placeholder="Select"
                      width="200"
                    >
                      <el-option
                        v-for="item in employmentTypeOptions"
                        :key="item"
                        :label="$helper.replaceUnderscore(item)"
                        :value="item"
                      >
                      </el-option>
                    </el-select>
                  </el-form-item>
                </el-col>
                <el-col
                  :span="12"
                  :md="12"
                  :sm="24"
                  :xs="24"
                  class="col-p flex"
                >

                  <el-form-item
                    class="mr-20"
                    label="Salary/Wages"
                    prop="salary_from"
                  ><br>
                    From
                    <el-input-number
                      :min="0"
                      :rows="10"
                      v-model="detail.salary_from"
                      label="From"
                    />

                  </el-form-item><br>
                  <el-form-item prop="salary_to"><br>
                    To
                    <el-input-number
                      :min="0"
                      :rows="10"
                      v-model="detail.salary_to"
                      label="To"
                    />

                  </el-form-item>
                </el-col>

              </el-row>
              <el-row :gutter="30">
                <el-col
                  :span="12"
                  :md="12"
                  :sm="24"
                  :xs="24"
                  class="col-p"
                >
                  <el-form-item
                    label="Position"
                    prop="position"
                  >
                    <el-input v-model="detail.position"></el-input>
                  </el-form-item>
                </el-col>
                <el-col
                  :span="12"
                  :md="12"
                  :sm="24"
                  :xs="24"
                  class="col-p"
                >
                  <el-form-item
                    label="Extra compensation"
                    prop="salary_extra"
                  >
                    <el-input
                      type="text"
                      v-model="detail.salary_extra"
                    />
                  </el-form-item>
                </el-col>

              </el-row>
              <el-row :gutter="30">
                <el-col
                  :span="12"
                  :md="24"
                  :sm="24"
                  :xs="24"
                  class="col-p"
                >
                  <el-form-item
                    label="Description"
                    prop="description"
                  >
                    <el-input
                      type="textarea"
                      :rows="5"
                      v-model="detail.description"
                    />
                  </el-form-item>
                </el-col>

                <!-- <el-col :span="12" :md="8" :sm="24" :xs="24" class="col-p">
                                    <el-form-item label="Experience Required"
                                    prop="experience">
                                    <br>
                                        <el-radio v-model="detail.experience" :label="1" >Yes</el-radio>
                                        <el-radio v-model="detail.experience" :label="0">No</el-radio>
                                    </el-form-item>
                                </el-col> -->

              </el-row>

              <el-row :gutter="30">

              </el-row>
              <!-- End row -->

              <!-- start row -->
              <el-row>
                <el-col
                  :span="12"
                  :md="12"
                  :sm="24"
                  :xs="24"
                  class="col-p"
                >

                </el-col>
              </el-row>
              <!-- end row -->
              <div>
                <div class="btn-right">
                  <el-button
                    class="mb-20"
                    icon="mdi mdi-content-save-outline"
                    type="primary"
                    @click="saveUpdate('detail')"
                  > Save changes</el-button>
                </div>
              </div>
            </el-form>
          </el-card>
        </div>
      </div>

      <view-image
        :dialogvisible.sync="dialogvisible"
        :imageUrl.sync="imageUrl"
      >
      </view-image>
    </div>
  </el-card>
</template>

<script>
import ViewImage from "~/components/dialogs/ViewImage";
import { job as jobAPI, category as categoryAPI, media as mediaAPI } from '~/services/apis/index'
import GMaps from './map.vue'
import NotFound from '../ContentNotFound'
import helper from '~/services/helper'
export default {
  name: 'JobDetail',
  components: {
    GMaps,
    NotFound,
    ViewImage,
  },
  data () {
    var validateSalaryFrom = (rule, value, callback) => {
      if (value === 0) {
        callback(new Error('Please input the salary greater than 0'));
      } else if (!Number.isInteger(value)) {
        callback(new Error('Please input digits'));
      }
      else if (value > this.detail.salary_to) {
        callback(new Error('Salary From must smaller than Salary To'));
      } else {
        callback();
      }
    };
    var validateSalaryTo = (rule, value, callback) => {

      if (value === 0) {
        callback(new Error('Please input the salary greater than 0'));
      } else if (value < this.detail.salary_from) {
        callback(new Error('Salary To must greater than Salary From'));
      } else {
        callback();
      }
    };

    return {
      detail: {
        name: '',
        timePost: '',
        position: '',
        description: '',
        categoryName: "",
        employmentOptionSelected: "",
        employmentTypeSelected: "",
        categorySelected: "",
        experience: '',
        salary: "",
        salary_to: "",
        salary_from: "",
        salary_extra: '',
        cover: "",
        companyName: "",
        companyDescription: "",
      },
      rules: {
        position: [
          { required: true, message: 'Please input position', trigger: 'blur' },
          { max: 255, message: 'Length should be 1 to 255', trigger: 'blur' }
        ],
        description: [
          { required: true, message: 'Please input description', trigger: 'blur' },
        ],
        categorySelected: [
          { required: true, message: 'Please select category', trigger: 'change' },
        ],
        employmentOptionSelected: [
          { required: true, message: 'Please select category', trigger: 'change' },
        ],
        employmentTypeSelected: [
          { required: true, message: 'Please select category', trigger: 'change' },
        ],
        experience: [
          { required: true, message: 'Please select experience', trigger: 'change' }
        ],
        salary_to: [{ required: true, validator: validateSalaryTo, trigger: 'blur' }],
        salary_from: [{ required: true, validator: validateSalaryFrom, trigger: 'blur' }],
        // salary_to: [
        //     { required: true, message: 'Please input salary to', trigger: 'change' }
        // ],
        // salary_from: [
        //     { required: true, message: 'Please input salary from', trigger: 'change' }
        // ],
      },
      postsList: [],
      loading: true,
      employmentTypeOptions: ['part_time', 'full_time'],
      employmentOptions: ['immediate_start', 'start_after_30_day'],
      categoriesOptions: [],
      postLoading: true,
      currentPage: 1,
      total: 0,
      slider: [],
      pageSize: this.$store.state.itemPerPage,
      isContentFound: false,
      dialogvisible: false,
      imageUrl: null,
      listImage: [
        {
          id: '',
          job_id: '',
          src: "",
          file: null,
          position: '',
        },
        {          id: '',
          job_id: '',
          src: "",
          file: null,
          position: ''
        },
        {
          id: '',
          job_id: '',
          src: "",
          file: null,
          position: ''
        },
        {
          id: '',
          job_id: '',
          src: "",
          file: null,
          position: ''
        },
        {
          id: '',
          job_id: '',
          src: "",
          file: null,
          position: ''
        },
        {
          id: '',
          job_id: '',
          src: "",
          file: null,
          position: ''
        },
      ],
      imageIndex: "",
      file: [null, null, null, null, null, null],
      mapvisible: false,
      address: "",
      onChangeIconHandle: [
        this.onchangeIcon0,
        this.onchangeIcon1,
        this.onchangeIcon2,
        this.onchangeIcon3,
        this.onchangeIcon4,
        this.onchangeIcon5
      ],
      imageLoading: false,
      newPostion: '',
      idDraggable: '',
      futureIndex: '',
    }
  },
  methods: {
    updatePostionImage () {
      /*eslint-disable*/
      this.imageLoading = true
      let id = this.idDraggable
      let position = this.newPostion
      console.log('this.newPostion :', this.newPostion);
      jobAPI.updatePostionImages(id, { position }).then(res => {
        if (res.data.success) {
          this.$notify({
            title: "Success",
            message: "Update position successfully!!!",
            type: "success"
          })
          this.getImagesJob();
          this.imageLoading = false
        }
      })
        .catch(err => {
          this.$notify({
            title: "Error",
            message: "Update position failed!",
            type: "error"
          });
          this.listImage.forEach(e => {
            e.src = null
            e.position = null
          })
          this.getImagesJob();
          this.imageLoading = false
        })
    },


    getPostion (evt) {
      /*eslint-disable*/
      this.newPostion = '';
      console.log('evt :', evt);
      if (!evt.draggedContext.element.src) {
        return false;
      }
      this.futureIndex = '';
      this.newPostion = '';
      if (evt.relatedContext && evt.relatedContext.element && evt.draggedContext.element) {
        this.newPostion = evt.relatedContext.index + 1
        this.idDraggable = evt.draggedContext.element.id
        this.futureIndex = evt.draggedContext.futureIndex
      }

    },
    saveUpdate (formName) {

      if (!this.$refs[formName]) return false;
      this.$refs[formName].validate(valid => {
        let data = {
          position: this.detail.position,
          description: this.detail.description,
          employment_type: this.detail.employmentTypeSelected,
          employment_option: this.detail.employmentOptionSelected,
          exp_require: this.detail.experience,
          salary_from: this.detail.salary_from,
          salary_to: this.detail.salary_to,
          salary_extra: this.detail.salary_extra,
          category_id: this.detail.categorySelected
        };
        /*eslint-disable*/
        // console.log('data :', data);
        if (valid) {
          jobAPI.updateJob(this.$route.params.id, data).then(res => {
            this.$notify({
              title: "Success",
              message: "Update successfully!!!",
              type: "success"
            })
            this.loading = false;
            this.$router.push({ name: 'jobs_detail' });
          }).catch(err => {
            this.$notify({
              title: "Error",
              message: "Update failed!",
              type: "error"
            });
          });
        } else {
          this.loading = false;
          return false;
        }
      });

    },
    getSeekerDetail () {
      if (!this.$route || !this.$route.params.id) return;
      jobAPI.getJob(this.$route.params.id)
        .then((res) => {
          this.initDetail(res.data.data);
          this.isContentFound = false;
          this.loading = false;
        })
        .catch((err) => {
          this.isContentFound = true;
          this.loading = false;
        })
    },
    getCategories () {
      this.loading = true;
      categoryAPI.getCategories().then(res => {
        if (res.data.success) {
          /*eslint-disable*/
          // console.log('res :', res.data.data);

          this.categoriesOptions = [...res.data.data]
          this.isContentFound = false;
          this.loading = false;
        }
      })
        .catch(err => {
          this.isContentFound = true;
          this.loading = false;
        })
    },
    initDetail (data) {
      if (!data) return;

      this.detail.name = data.position;
      this.detail.position = data.position;
      this.detail.description = data.description;
      this.detail.timePost = data.created_at;
      this.detail.employmentTypeSelected = data.employment_type;

      this.detail.employmentOptionSelected = data.employment_option
      this.detail.experience = data.exp_require;
      this.detail.location = data.location;
      this.detail.salary_to = data.salary_to;
      this.detail.salary_from = data.salary_from;
      this.detail.salary = this.formatSalary(data.salary_from, data.salary_to);
      this.detail.salary_extra = data.salary_extra;
      if (data.category && data.category.name)
        this.detail.categorySelected = data.category.id;

      // if(data.logo && data.logo.url)
      //     this.detail.cover = data.logo.url;
      //      this.listImage[0].src = this.detail.cover


    },
    /*Create new image for job*/
    createImage (data) {
      this.imageLoading = true;
      jobAPI.createJobImage(data).then(res => {
        // console.log('res create Image :', res);
        if (res.data.success) {
          this.$notify({
            title: "Success",
            message: "Upload image successfully!!!",
            type: "success"
          })
          this.getImagesJob();
          this.imageLoading = false;
        }
      })
        .catch(err => {
          this.$notify({
            title: "Error",
            message: "Upload image failed!!!",
            type: "error"
          })
          console.log('err :', err);
          this.imageLoading = false;
        })
    },
    /* Upload image */
    uploadImage (data, index) {
      this.imageLoading = true;
      if (data) {
        mediaAPI.upload(this.file[index]).then(res => {
          if (res.data.success) {
            let data = {
              job_id: this.$route.params.id,
              path: res.data.data.path
            }
            this.listImage[index].src = null
            this.createImage(data)
            console.log('res', res.data.data.path);
          }
        });
      }
      this.imageLoading = false;
    },
    /*On Image Change*/
    onChangeIcon (file, fileList, index) {
      console.log(file, fileList, index);
      if (!file) return;
      if (this.listImage[index].src) {
        return
      } else {
        this.listImage[index].src = URL.createObjectURL(file.raw);
        this.file[index] = file.raw;
        console.log('this.file[index] :', this.file);
        this.uploadImage(this.file, index);
        // jobAPI.removeJobImages(this.listImage[index].id)
        //     .then(res => {
        //       if(res.data.success) {
        //         this.listImage[index].src = URL.createObjectURL(file.raw);
        //         this.file[index] = file.raw;
        //         console.log('this.file[index] :', this.file);
        //         this.uploadImage(this.file,index);
        //       }
        //     })
        //     .catch(err => {
        //         console.log('err :', err);
        //     })
      }
    },
    onchangeIcon0 (file, fileList) {
      this.onChangeIcon(file, fileList, 0)
    },
    onchangeIcon1 (file, fileList) {
      this.onChangeIcon(file, fileList, 1)
    },
    onchangeIcon2 (file, fileList) {
      this.onChangeIcon(file, fileList, 2)
    },
    onchangeIcon3 (file, fileList) {
      this.onChangeIcon(file, fileList, 3)
    },
    onchangeIcon4 (file, fileList) {
      this.onChangeIcon(file, fileList, 4)
    },
    onchangeIcon5 (file, fileList) {
      this.onChangeIcon(file, fileList, 5)
    },
    formatSalary (from, to) {
      if (!from && !to) {
        return ""
      }

      return "From " + helper.formatNumber(from) + " To " + helper.formatNumber(to);
    },
    onChangePage (page) {
      this.currentPage = this.$helper.formatPage(page)
      //this.$router.push({query: {page: page}})
      this.getListPost();
    },
    /* Get all images job*/
    getImagesJob () {
      this.imageLoading = true;
      jobAPI.getImagesJob(this.$route.params.id)
        .then(res => {
          if (res.data.success) {
            res.data.data.sort((a, b) => parseInt(a.position) - parseInt(b.position));
            for (let i = 0; i < res.data.data.length || res.data.data.length > 6 ? res.data.data.length = 6 : res.data.data.length; i++) {

              this.listImage[i].id = res.data.data[i].id
              this.listImage[i].job_id = res.data.data[i].job_id
              this.listImage[i].src = res.data.data[i].url
              this.listImage[i].position = res.data.data[i].position

            }
            console.log('this.listImage :', this.listImage);
          }
          this.imageLoading = false
        })
        .catch(err => {
          console.log(err);
          this.imageLoading = false
        })
    },
    onRemoveImg (e, id, index) {
      this.$confirm('Are you sure you want to delete this image?', 'Warning', {
        confirmButtonText: 'Yes',
        cancelButtonText: 'Cancel',
        type: 'warning',
        center: true
      }).then(() => {
        this.imageLoading = true;
        e.preventDefault();
        e.stopPropagation();
        jobAPI.removeJobImages(id).then(res => {
          if (res.data.success) {
            this.$notify({
              title: "Success",
              message: "Remove image successfully!",
              type: "success"
            });
          }
          this.listImage.forEach(e => {
            e.src = null
          })
          this.getImagesJob();
          this.imageLoading = false
        }).catch(err => {
          this.$notify({
            title: "Error",
            message: "Remove failed!",
            type: "error"
          });

        })
      }).catch(err => {

      })
    },
    removeImg () {
      this.imageName = "";
      this.file = null;
      this.updateIcon = true;
      this.detail.cover = "";
    },

  },
  created () {
    this.getImagesJob();
    this.getCategories();
    this.getSeekerDetail();

  },

  watch: {
    idDraggable () {
      return this.idDraggable
    },
    newPostion () {
      return this.newPostion
    }
  }
}
</script>

<style lang="scss">
.salary-d-flex {
  display: flex;
}
.img-content {
  width: 100px;
  height: 100px;
  position: relative;
  background-color: #63696c;
}

.giveMeEllipsis {
  overflow: hidden;
  text-overflow: ellipsis;
  display: -webkit-box;
  -webkit-box-orient: vertical;
  -webkit-line-clamp: 3; /* number of lines to show */
  /*line-height: 3;        !* fallback *!*/
  /*max-height: 10px;       !* fallback *!*/
}
</style>
